﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using SodukoSolverClassLibrary;

namespace SodukoConsoleApplication
{
    class Program
    {
        static void Main(string[] args)
        {
            //Test1();
            //Test0();
            TestHard1();
            TestHard2();

            Console.ReadLine();
        }

        public static void TestHard1()
        {
            int[,] board = {
                                {8,0,0,0,0,0,0,0,0},
                                {0,0,3,6,0,0,0,0,0},
                                {0,7,0,0,9,0,2,0,0},
                                {0,5,0,0,0,7,0,0,0},
                                {0,0,0,0,4,5,7,0,0},
                                {0,0,0,1,0,0,0,3,0},
                                {0,0,1,0,0,0,0,6,8},
                                {0,0,8,5,0,0,0,1,0},
                                {0,9,0,0,0,0,4,0,0}
                           };
            Console.WriteLine("board");
            Console.WriteLine(SodukoSolver.Board2String(board));
            bool isSolved1 = SodukoSolver.Solve(board);
            Console.WriteLine(isSolved1 ? "Løst" : "Ikke løst");
            Console.WriteLine(SodukoSolver.Board2String(board));

            Console.ReadLine();
        }
        public static void TestHard2()
        {
            int[,] board = {
                                {1,0,0,0,0,7,0,9,0},
                                {0,3,0,0,2,0,0,0,8},
                                {0,0,9,6,0,0,5,0,0},
                                {0,0,5,3,0,0,9,0,0},
                                {0,1,0,0,8,0,0,0,2},
                                {6,0,0,0,0,4,0,0,0},
                                {3,0,0,0,0,0,0,1,0},
                                {0,4,0,0,0,0,0,0,7},
                                {0,0,7,0,0,0,3,0,0}
                            };
            Console.WriteLine("board");
            Console.WriteLine(SodukoSolver.Board2String(board));
            bool isSolved1 = SodukoSolver.Solve(board);
            Console.WriteLine(isSolved1 ? "Løst" : "Ikke løst");
            Console.WriteLine(SodukoSolver.Board2String(board));

            Console.ReadLine();
        }
        public static void Test1()
        {
            int[,] board = {
                                    {0,0,0,2,6,0,7,0,1},
                                    {6,8,0,0,7,0,0,9,0},
                                    {1,9,0,0,0,4,5,0,0},
                                    {8,2,0,1,0,0,0,4,0},
                                    {0,0,4,6,0,2,9,0,0},
                                    {0,5,0,0,0,3,0,2,8},
                                    {0,0,9,3,0,0,0,7,4},
                                    {0,4,0,0,5,0,0,3,6},
                                    {7,0,3,0,1,8,0,0,0}
                                };
            Console.WriteLine("board");
            Console.WriteLine(SodukoSolver.Board2String(board));
            bool isSolved1 = SodukoSolver.Solve(board);
            Console.WriteLine(isSolved1 ? "Løst" : "Ikke løst");
            Console.WriteLine(SodukoSolver.Board2String(board));

            Console.ReadLine();
        }
        public static void Test0()
        {
            int[,] board = {
                                {0,0,0,0,0,0,0,0,0},
                                {0,0,0,0,0,0,0,0,0},
                                {0,0,0,0,0,0,0,0,0},
                                {0,0,0,0,0,0,0,0,0},
                                {0,0,0,0,0,0,0,0,0},
                                {0,0,0,0,0,0,0,0,0},
                                {0,0,0,0,0,0,0,0,0},
                                {0,0,0,0,0,0,0,0,0},
                                {0,0,0,0,0,0,0,0,0}
                            };
            Console.WriteLine("board");
            Console.WriteLine(SodukoSolver.Board2String(board));
            bool isSolved0 = SodukoSolver.Solve(board);
            Console.WriteLine(isSolved0 ? "Løst" : "Ikke løst");
            Console.WriteLine(SodukoSolver.Board2String(board));

            Console.ReadLine();
        }
    }
}
